program poissonsolver
  use m_poisson
  use omp_lib
  implicit none

  integer :: nx, ny
  real(kind=8) :: lx, ly
  real(kind=8) :: dx, dy
  integer :: fileno = 42, Ffileno=43
  integer :: maxiter, interval = -1
  real(kind=8) :: maxerr = 1e-7

  real(kind=8) :: time1, time2
  
  real(kind=8), dimension(:, :), allocatable :: T, U, F

  !maxiter = 200
  !nx = 20
  read*, nx, maxiter
  ny = nx

  lx = 2.0
  ly = 2.0

  dx = lx / real(nx - 1)
  dy = ly / real(ny - 1)

  allocate(T(ny, nx), U(ny, nx), F(ny, nx))

  write(unit=0, *) 'size:', nx, '; iter:', maxiter, &
       '; cpus:', omp_get_max_threads()

!$omp parallel workshare
  T = 0.0
  U = 0.0
  F = 0.0
!$omp end parallel workshare

  call initialize_boundary_conditions(T, U, F, nx, ny, dx, dy)

  time1 = omp_get_wtime()
  !call jacobi(T, U, F, nx, ny, maxiter, interval, maxerr)
  !call redblack_gaussseidel(T, F, nx, ny, maxiter, interval, maxerr)
  call gaussseidel(T, F, nx, ny, maxiter, interval, maxerr)
  time2 = omp_get_wtime()

  print*, omp_get_max_threads(), time2 - time1

  !open(fileno, file='field.dat')
  !call savearray(T, nx, ny, dx, dy, fileno)
  !close(fileno)

  deallocate(T, U, F)

end program poissonsolver
