program poissonsolver
  use m_poisson
  use omp_lib
  implicit none

  integer :: nx, ny
  real(kind=8) :: lx, ly
  real(kind=8) :: dx, dy
  integer :: fileno = 42, Ffileno=43
  integer :: maxiter, interval = -1
  real(kind=8) :: maxerr = 1e-7

  real(kind=8) :: time1, time2
  
  real(kind=8), dimension(:, :), allocatable :: T, U, F

  maxiter = 200
  nx = 3200
  read*, nx, maxiter
  ny = nx

  lx = 2.0
  ly = 2.0

  dx = lx / real(nx - 1)
  dy = ly / real(ny - 1)

  allocate(T(ny, nx), U(ny, nx), F(ny, nx))

  call initialize_boundary_conditions(T, U, F, nx, ny, dx, dy)

  !open(Ffileno, file='F.dat')
  !call savearray(F, nx, ny, dx, dy, Ffileno)
  !close(Ffileno)

  time1 = omp_get_wtime()
  call solve(T, U, F, nx, ny, jacobi, maxiter, interval, maxerr)
  time2 = omp_get_wtime()

  print*, omp_get_max_threads(), time2 - time1

  !open(fileno, file='field.dat')
  !call savearray(T, nx, ny, dx, dy, fileno)
  !close(fileno)

end program poissonsolver
