program poissonsolver
  use m_poisson
  use omp_lib
  implicit none

  integer :: nx = 1600, ny = 1600
  real(kind=8) :: lx, ly
  real(kind=8) :: dx, dy
  integer :: fileno = 42, Ffileno=43
  
  real(kind=8), dimension(:, :), allocatable :: T, U, F

  real(kind=8) :: time1, time2

  lx = 2.0
  ly = 2.0

  dx = lx / real(nx - 1)
  dy = ly / real(ny - 1)

  allocate(T(ny, nx), U(ny, nx), F(ny, nx))

  call initialize_boundary_conditions(T, F, nx, ny, dx, dy)

  U = T

  !open(Ffileno, file='F.dat')
  !call savearray(F, nx, ny, dx, dy, Ffileno)
  !close(Ffileno)


  time1 = omp_get_wtime()
  !call solve(T, U, F, nx, ny, gaussseidel)
  call solve(T, U, F, nx, ny, gaussseidel)
  time2 = omp_get_wtime()

  !open(fileno, file='field.dat')
  !call savearray(T, nx, ny, dx, dy, fileno)
  !close(fileno)
  print*, time2 - time1

end program poissonsolver
